/* FW_Tutorial.rexx 1.0 (04.01.95) by NDY's

Interactive tutorial. */


/* Initialisation (this one or a similar code should be used by all FW macros)
   The first IF statement could also be replaced by a simple:
     IF ~Show("P",rxport) THEN EXIT 10
   With this, the macro will only work if FinalWrapper is already started */

/* BEGIN init */
OPTIONS RESULTS
rxport="FinalWrapperPort"
IF ~Show("P",rxport) THEN /* Port not found? */
  DO
    /* Read FinalWrapper's default macro path */
    IF Open("path","ENV:FinalWrapper/FWPath","R") THEN
      DO
        path=ReadLn("path")
        CALL Close("path")
      END
    ELSE
      path=""
    /* Run FinalWrapper */
    ADDRESS COMMAND "Run >NIL: Rx" path||"FinalWrapper.rexx"
    /* Wait for port to be created */
    DO i=1 TO 10 WHILE ~Show("P",rxport)
      ADDRESS COMMAND "Wait 3 SECS" /* Wait a moment */
    END
    /* Still not found? -> EXIT  */
    IF ~Show("P",rxport) THEN EXIT 10
  END
ADDRESS VALUE rxport
Lock ON
Prefs STORE
SIGNAL ON ERROR
/* END Init */

/* Initialize localized strings */
CALL locale
/* Final Writer started? */
Get PORT
IF RESULT="" THEN
  DO
    Message nofw
    CALL ERROR
  END
/* reqtools available? */
Get REQTOOLS
IF RESULT=0 THEN
  DO
    Message noreqtools
    CALL ERROR
  END
/* Set default settings */
Use MDEF
title="FinalWrapper Tutorial 1.0 by NDY's"
Set WINDOW title

/* Begin of tutorial */
DO i=1 TO steps UNTIL ~ok
  ok=message(t.i,b.i)
END
/* END of tutorial */

/* Exit */
ERROR:
  Set WINDOW
  Prefs RESET
  Lock OFF
  EXIT
RETURN
locale:
  IF Open(prefs,"ENV:Language","R") THEN
    DO
      language=ReadLn(prefs)
      CALL Close(prefs)
    END
  ELSE
    language="english"
  SELECT
  WHEN language="deutsch" THEN
    DO
      nofw="Bitte_Final_Writer_starten|und_nochmals_versuchen!"
      noreqtools="Dieses_Makro_braucht_die folgenden|Libraries:||rexxreqtools.library|reqtools.library"
      steps=15
      DO i=1 TO steps
        b.i="Hab ich gemacht, weiter geht's!|Abbruch"
      END
      t.1="Willkommen zur Einfhrung in FinalWrapper!||Sie werden die Grundzge von Final-|Wrapper (in dieser Einleitung einfach|FW genannt) anhand eines einfachen|Beispiels kennenlernen.||In der Folge erscheinen einige Requester.|Alles was Sie tun mssen, ist den Anweisungen|zu folgen. Klicken Sie dann auf 'Weiter', um|fortzufahren.||Also dann... viel Glck!"
      b.1="Einfhrung beginnen|Abbruch"
      t.2="Zuerst probieren wir die Online-Hilfe aus!||Whlen Sie den Menupunkt 'Hilfe' im Menu von FW.|Vergessen Sie nicht, erst FWs Fenster zu aktivieren!||Es sollte dann ein AmigaGuide-Text ber alle|Schalter und Menupunkte von FW angezeigt|werden.||Wenn ein Requester mit der Meldung 'Online-Hilfe|nicht verfgbar' erscheinen sollte, existiert ent-|weder kein deutscher Hilfstext, oder Sie haben die|'amigaguide.library' nicht installiert (fr weitere|Details ziehen Sie bitte die Anleitung zu Rate!).|In diesem Fall knnen Sie die folgenden zwei|Requester ebenfalls berspringen."
      t.3="Gut gemacht! Jetzt versuchen wir die Hilfe|fr Schalter!||Bewegen Sie den Mauszeiger ber einen|Schalter in FWs Fenster (wiederum nicht|vergessen, das Fenster zu aktivieren!) und|drcken Sie die Help-Taste.||Es wird dann ein kurzer Text ber den Schalter|unter dem Mauszeiger erscheinen."
      t.4="Und jetzt die Hilfe fr das Menu...||Drcken Sie die rechte Maustaste,|und bewegen Sie den Mauszeiger|ber irgend einen Menupunkt.|Drcken Sie dann wieder die Help-|Taste (bevor Sie die Maustaste|loslassen!).||Wen wundert's: Es wird ein Text ber|den Menupunkt angezeigt."
      t.5="Ok, beginnen wir unser erstes Projekt!||Wir wollen einen Text erzeugen, der|ungefhr folgendermassen aussieht:||               o  d  u            |           r                c        |        t                      i     |     n                          n  |    I                            g|    -                             -|    F                            r |     i                          e  |       n                     p     |          a               p        |             l  W  r  a           ||Dies ist eine einfache Aufgabe fr FW!"
      b.5="Ok, fangen wir an!|Abbruch"
      t.6="Zuerst mssen wir das Oval definieren.|Wir tun dies, indem wir die Position und|die Grsse in die entsprechenden Felder|eingeben. (Wir knnten auch einfach ein|Oval mit Final Writer zeichnen).||Unser Oval soll 2 cm weg vom oberen|und vom linken Rand zu liegen kommen.|Geben Sie also 2 ins X und ins Y Feld ein.|Breite und Hhe sollen beide 5 cm sein,|geben Sie daher 5 in beide Felder ein.||(Sollten Sie Inch oder Pica verwenden,|mssen Sie die Werte entsprechend|anpassen.)"
      t.7="Jetzt wird es Zeit fr den Text!|Wir beginnen mit dem oberen Teil.||Geben Sie also '- Introducing -'|ins Text feld ein."
      t.8="Der Text sollte um das halbe Oval herum|laufen. Daher brauchen wir einen Sektor von 180.|Geben Sie also 180 in das Feld neben 'Nutze|Sektor'ein (dasjenige, das 360 anzeigt).|Der Schalter mit dem Hkchen wird automatisch|angewhlt sobald Sie den Wert eingegeben|haben. Wenn dieser Schalter nicht angewhlt|ist, wird die Option einfach ignoriert! Das|erlaubt Ihnen, Optionen, die Sie nicht mehr|bentigen, abzuschalten."
      t.9="Lassen wir nun die erste Hlfte unseres|Textes zeichnen!||Klicken Sie auf Ok.||Das Fenster wird sogleich verkleinert,|so dass nur noch die Titelleiste sichtbar|bleibt. Sobald es wieder seine normale|Grsse annimmt, ist die Operation|beendet."
      t.10="Fahren wir weiter mit den zweiten Teil.||Tippen Sie nun 'FinalWrapper' ins Textfeld."
      t.11="Der Sektor msste wieder 180 sein.|Wir machen ihn ein wenig kleiner, um|einen kleinen Leerraum einzufgen...|sagen wir 170. Dies ist der neue Wert|fr das Sektor-Feld.||Der Text soll im Gegenuhrzeigersinn|geschrieben werden, daher mssen|wir den Schalter auf 'Nutze Sektor:|Gegenuhrz.' umschalten."
      t.12="Wrden wir jetzt Ok anwhlen, wrde|der neue Text genau ber demjenigen|erscheinen, den wir bereits erstellt haben.|Da wir ihn aber unten am Oval haben|mchten, muss er um 180 gedreht werden.||Dies kann mit dem Position-Schalter|erreichnt werden: Setzen Sie ihn auf|'Uhrzeigersinn' (oder 'Gegenuhrzeiger',|da ja 180 in beiden Richtungen dasselbe|ist) und geben Sie 180 als Wert ein."
      t.13="Wir wollen noch eine andere Schrift und|Farbe fr den zweiten Teil verwenden:|Whlen Sie den Menupunkt 'Textblock-|Einstellungen'. Es wird dann Final Writers|Textblock Requester angezeigt, in dem|Sie die neue Farbe und Schrift auswhlen|knnen."
      t.14="Klicken Sie erneut auf Ok und warten Sie,|bis das Ganze fertig ist.||Das Einzige, was uns zu tun bleibt, ist,|die beiden Objekte zu Gruppieren, was|ein spteres Herumschieben vereinfacht."
      t.15="Das war's!||Jetzt, da Sie Ihre ersten Schritte mit|FinalWrapper hinter sich haben, knnen|Sie die Anleitung lesen (oder einfach|die Online-Hilfe verwenden), um die|anderen Effekte auszuprobieren.||Sollten Sie wirklich Probleme haben (was|ich nicht hoffe!), schreiben Sie mir einfach|(aber bitte erst, nachdem Sie die Anleitung|studiert haben!).||Meine Adresse ist im 'ber'-Requester zu|finden.||Viel Spass mit dem Makro!||                   ND"
      b.15="Wiedersehen"
    END
  OTHERWISE
    DO
      nofw="Please_start_Final_Writer|and_try_again!"
      noreqtools="This_macro_needs_the following|libraries_to_run:||rexxreqtools.library|reqtools.library"
      steps=15
      DO i=1 TO steps
        b.i="I've done so, let's go on!|Abort"
      END
      t.1="Welcome to the FinalWrapper tutorial!||You'll be introduced to the basics of|FinalWrapper (in this tutorial simply|called FW) with an easy example.||There will be a series of requesters|appearing. All you have to do is to|follow the instructions in the requester|and then click on 'Let's go on!' to|continue.||Well then... good luck!"
      b.1="Start tutorial|Abort"
      t.2="First, let's try the online help!||Select the Help item in FW's menu. Don't forget|to activate FW's window first!||You should then be shown an AmigaGuide text|about all gadgets and menu items of FW.||If a requester appears saying 'Online help not|available', there's no help file for your language|or you don't have the amigaguide.library installed|(for further details consult the manual!). In this case|you can skip the following two requesters as well."
      t.3="Well done! Now we try the gadget help!||Move the mouse pointer over a gadget|in FW's window (again don't forget to|activate the window first!) and press the|Help key.||You should then be shown a short text|about the gadget beneath the pointer."
      t.4="And now try the menu help...||Press the right mouse button to view|the menu and move the mouse|pointer over anyone menu item.|Then press the Help key again (before|releasing the mouse button!).||Unsurprisingly, you'll be shown a text|about the menu item."
      t.5="Ok, let's start with our first project!||We want to create a text that|looks about like that:||               o  d  u            |           r                c        |        t                      i     |     n                          n  |    I                            g|    -                             -|    F                            r |     i                          e  |       n                     p     |          a               p        |             l  W  r  a           ||This is an easy task for FW!"
      b.5="Ok, let's begin!|Abort"
      t.6="To begin with, we have to define the oval.|We'll do this by entering the position and|size into the apropriate gadgets. (We|could also draw an oval in FinalWriter.)||Our oval should be placed 2 cm away|from the top and the left of the page.|So enter 2 in the X and in the Y gadget.|The width and height should both be 5 cm,|therefore enter 5 in both gadgets.||(If you're using Inch or Pica, you probably|have to modify the suggested values.)"
      t.7="Now we need the text!|We begin with the upper|part. So enter '- Introducing -'|into the text gadget."
      t.8="The text should use about half the|oval. This means we need a 180 arc.|Therefore enter 180 into the gadget|besides 'Use arc' (the one that reads 360).|The check gadget will be automatically|selected when you have entered|the value. Unless it is selected, the|option will be completely ignored!|This allows you to switch off any option|you don't want anymore."
      t.9="Now it's time to let the first half|of our text be drawn!||Click on the Ok gadget.||The window will be reduced in size,|only leaving the title bar visible.|When it changes to it's normal size|again, the drawing is finished."
      t.10="Let's continue with the second part.||Now type 'FinalWrapper' into the|text gadget."
      t.11="Again the arc would have to be 180.|We make it a little smaller to add|some space between... let's say 170.|This is the new value for the arc gadget.||The text has to be written anticlockwise,|so you have to change the gadget|to Use arc: Anticlockwise."
      t.12="If we would click on Ok now, the new|text would be placed exactly over the|one we already created. But we want|it at the bottom of the oval. This means|it has to be turned around by 180.||This can be done using the Begin gadget:|Set it to Clockwise (or Anticlockwise|as 180 in either direction is the same)|and enter 180 as value."
      t.13="Now let's use another font and colour|for our second part: Select the menu|item 'Textblock preferences'. You'll be|shown Final Writer's textblock requester|where you can set the new colour etc."
      t.14="Again click on Ok and wait till it's|finished.||The only thing we have to do now is|grouping the two objects together|so we can move them around easily."
      t.15="That's it!||Now you have done your first steps with|FinalWrapper, you can read the manual|(or just use the online help!) to explore the|other effects.||If you really should have troubles (I don't|hope so!), just write me (but please do|consult the manual first!).||My address can be found in the About|requester.||Have fun using the macro!||                   ND"
      b.15="Bye"
    END
  END
RETURN
message:
  PARSE ARG msg,button
  IF button="" THEN button="Ok"
  p=Pos("|",msg)
  DO WHILE p>0
    msg=Left(msg,p-1)||"0A"x||SubStr(msg,p+1)
    p=Pos("|",msg)
  END
  button=RTEZRequest(msg,button,title)
RETURN button

